# coding: utf-8

"""
    SendX REST API

    # Introduction SendX is an email marketing product. It helps you convert website visitors to customers, send them promotional emails, engage with them using drip sequences and craft custom journeys using powerful but simple automations. The SendX API is organized around REST. Our API has predictable resource-oriented URLs, accepts form-encoded request bodies, returns JSON-encoded responses, and uses standard HTTP response codes, authentication, and verbs. The SendX Rest API doesn’t support bulk updates. You can work on only one object per request. <br> 

    The version of the OpenAPI document: 1.0.0
    Contact: support@sendx.io
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from typing import Optional, Set
from typing_extensions import Self

class ContactRequest(BaseModel):
    """
    Schema for the contact request payload. Used for creating or updating a contact.
    """ # noqa: E501
    email: Optional[StrictStr] = Field(default=None, description="The email address of the contact. Must be a valid email.")
    first_name: Optional[StrictStr] = Field(default=None, description="The first name of the contact.", alias="firstName")
    last_name: Optional[StrictStr] = Field(default=None, description="The last name of the contact.", alias="lastName")
    company: Optional[StrictStr] = Field(default=None, description="The company where the contact works.")
    last_tracked_ip: Optional[StrictStr] = Field(default=None, description="The last known IP address of the contact.", alias="lastTrackedIp")
    custom_fields: Optional[Dict[str, StrictStr]] = Field(default=None, description="Custom fields specific to the contact, which may vary by account.", alias="customFields")
    lists: Optional[List[StrictStr]] = Field(default=None, description="A list of `lists` ids the contact is subscribed to.")
    tags: Optional[List[StrictStr]] = Field(default=None, description="Tag ids associated with the contact for segmentation or categorization.")
    __properties: ClassVar[List[str]] = ["email", "firstName", "lastName", "company", "lastTrackedIp", "customFields", "lists", "tags"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of ContactRequest from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of ContactRequest from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "email": obj.get("email"),
            "firstName": obj.get("firstName"),
            "lastName": obj.get("lastName"),
            "company": obj.get("company"),
            "lastTrackedIp": obj.get("lastTrackedIp"),
            "customFields": obj.get("customFields"),
            "lists": obj.get("lists"),
            "tags": obj.get("tags")
        })
        return _obj


